/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.tarifas;

import java.util.HashMap;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

import com.rjconsultores.ventaboletos.entidad.SegVKM;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderSegVKM;

/**
 * 
 * @author RJ
 */
@Controller("busquedaSegVKMController")
@Scope("prototype")
public class BusquedaSegVKmController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	@Autowired
	private transient PagedListWrapper<SegVKM> plwSerie;
	private MyListbox segVKmList;
	private Paging pagingSegVKm;
	private Textbox txtSerie;

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		super.doAfterCompose(comp);

		segVKmList.setItemRenderer(new RenderSegVKM());
		segVKmList.addEventListener("onDoubleClick", new EventListener() {

			@Override
			public void onEvent(Event event) throws Exception {
				SegVKM s = (SegVKM) segVKmList.getSelected();
				verSegVKm(s);
			}
		});

		refreshLista();

		txtSerie.focus();
	}

	private void verSegVKm(SegVKM s) {
		if (s == null) {
			return;
		}

		Map args = new HashMap();
		args.put("segVKM", s);
		args.put("segVKmList", segVKmList);

		openWindow("/gui/tarifas/editarSegVKm.zul",
				Labels.getLabel("busquedaSegVKmController.window.title"),
				args, MODAL);
	}

	private void refreshLista() {

		HibernateSearchObject<SegVKM> seguroKmBusqueda =
				new HibernateSearchObject<SegVKM>(SegVKM.class,
						pagingSegVKm.getPageSize());

		seguroKmBusqueda.addFilterEqual("activo", Boolean.TRUE);

		if (!txtSerie.getValue().equals("")) {
			seguroKmBusqueda.addFilterLike("serie",
					"%" + txtSerie.getText().trim().concat("%"));
		}

		seguroKmBusqueda.addSortAsc("serie");

		plwSerie.init(seguroKmBusqueda, segVKmList, pagingSegVKm);

		if (segVKmList.getData().length == 0) {
			try {
				Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
						Labels.getLabel("busquedaSegVKmController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);
			} catch (InterruptedException ex) {
			}
		}
	}

	public void onClick$btnPesquisa(Event ev) {
		refreshLista();
	}

	public void onClick$btnRefresh(Event ev) {
		refreshLista();
	}

	public void onClick$btnNovo(Event ev) {
		verSegVKm(new SegVKM());
	}

	public PagedListWrapper<SegVKM> getPlwSerie() {
		return plwSerie;
	}

	public void setPlwSerie(PagedListWrapper<SegVKM> plwSerie) {
		this.plwSerie = plwSerie;
	}

	public MyListbox getSegVKmList() {
		return segVKmList;
	}

	public void setSegVKmList(MyListbox segVKmList) {
		this.segVKmList = segVKmList;
	}

	public Paging getPagingSegVKm() {
		return pagingSegVKm;
	}

	public void setPagingSegVKm(Paging pagingSegVKm) {
		this.pagingSegVKm = pagingSegVKm;
	}

	public Textbox getTxtSerie() {
		return txtSerie;
	}

	public void setTxtSerie(Textbox txtSerie) {
		this.txtSerie = txtSerie;
	}
}
